<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_202) on Sat Apr 27 15:39:26 CEST 2019 -->
<title>DefaultBlrCalculator (Jaybird API)</title>
<meta name="date" content="2019-04-27">
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="DefaultBlrCalculator (Jaybird API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/firebirdsql/gds/ng/wire/AsynchronousProcessor.html" title="class in org.firebirdsql.gds.ng.wire"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/firebirdsql/gds/ng/wire/DeferredAction.html" title="interface in org.firebirdsql.gds.ng.wire"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html" target="_top">Frames</a></li>
<li><a href="DefaultBlrCalculator.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.firebirdsql.gds.ng.wire</div>
<h2 title="Class DefaultBlrCalculator" class="title">Class DefaultBlrCalculator</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.firebirdsql.gds.ng.wire.DefaultBlrCalculator</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html" title="interface in org.firebirdsql.gds.ng.fields">BlrCalculator</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">DefaultBlrCalculator</span>
extends <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>
implements <a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html" title="interface in org.firebirdsql.gds.ng.fields">BlrCalculator</a></pre>
<div class="block">Default BLR calculator for the wire protocol.
 <p>
 Most likely this can be used without change for other protocol versions as well, although we may need to investigate
 the TODOs specified in <a href="../../../../../org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html#calculateBlr-org.firebirdsql.gds.ng.fields.RowDescriptor-"><code>calculateBlr(org.firebirdsql.gds.ng.fields.RowDescriptor)</code></a>.
 </p></div>
<dl>
<dt><span class="simpleTagLabel">Since:</span></dt>
<dd>3.0</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd><a href="mailto:mrotteveel@users.sourceforge.net">Mark Rotteveel</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static <a href="../../../../../org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html" title="class in org.firebirdsql.gds.ng.wire">DefaultBlrCalculator</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html#CALCULATOR_DIALECT_3">CALCULATOR_DIALECT_3</a></span></code>
<div class="block">Cached instance of <a href="../../../../../org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html" title="class in org.firebirdsql.gds.ng.wire"><code>DefaultBlrCalculator</code></a> for dialect 3 databases.</div>
</td>
</tr>
</table>
</li>
</ul>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html#DefaultBlrCalculator-short-">DefaultBlrCalculator</a></span>(short&nbsp;dialect)</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html#calculateBlr-org.firebirdsql.gds.ng.fields.RowDescriptor-">calculateBlr</a></span>(<a href="../../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;rowDescriptor)</code>
<div class="block">Calculates the blr for the row descriptor.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>byte[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html#calculateBlr-org.firebirdsql.gds.ng.fields.RowDescriptor-org.firebirdsql.gds.ng.fields.RowValue-">calculateBlr</a></span>(<a href="../../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;rowDescriptor,
            <a href="../../../../../org/firebirdsql/gds/ng/fields/RowValue.html" title="class in org.firebirdsql.gds.ng.fields">RowValue</a>&nbsp;rowValue)</code>
<div class="block">Calculates the blr for a specific row value.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html#calculateIoLength-org.firebirdsql.gds.ng.fields.FieldDescriptor-">calculateIoLength</a></span>(<a href="../../../../../org/firebirdsql/gds/ng/fields/FieldDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">FieldDescriptor</a>&nbsp;fieldDescriptor)</code>
<div class="block">Calculates the io length for the field descriptor.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../../org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html#calculateIoLength-org.firebirdsql.gds.ng.fields.FieldDescriptor-byte:A-">calculateIoLength</a></span>(<a href="../../../../../org/firebirdsql/gds/ng/fields/FieldDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">FieldDescriptor</a>&nbsp;fieldDescriptor,
                 byte[]&nbsp;fieldData)</code>
<div class="block">Calculates the io length for the field descriptor and actual data.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="CALCULATOR_DIALECT_3">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>CALCULATOR_DIALECT_3</h4>
<pre>public static final&nbsp;<a href="../../../../../org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html" title="class in org.firebirdsql.gds.ng.wire">DefaultBlrCalculator</a> CALCULATOR_DIALECT_3</pre>
<div class="block">Cached instance of <a href="../../../../../org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html" title="class in org.firebirdsql.gds.ng.wire"><code>DefaultBlrCalculator</code></a> for dialect 3 databases.</div>
</li>
</ul>
</li>
</ul>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="DefaultBlrCalculator-short-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>DefaultBlrCalculator</h4>
<pre>public&nbsp;DefaultBlrCalculator(short&nbsp;dialect)</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="calculateBlr-org.firebirdsql.gds.ng.fields.RowDescriptor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>calculateBlr</h4>
<pre>public&nbsp;byte[]&nbsp;calculateBlr(<a href="../../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;rowDescriptor)
                    throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html#calculateBlr-org.firebirdsql.gds.ng.fields.RowDescriptor-">BlrCalculator</a></code></span></div>
<div class="block">Calculates the blr for the row descriptor.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html#calculateBlr-org.firebirdsql.gds.ng.fields.RowDescriptor-">calculateBlr</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html" title="interface in org.firebirdsql.gds.ng.fields">BlrCalculator</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>rowDescriptor</code> - Row descriptor</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Byte array with the blr</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - When the <a href="../../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields"><code>RowDescriptor</code></a> contains an unsupported field type.</dd>
</dl>
</li>
</ul>
<a name="calculateBlr-org.firebirdsql.gds.ng.fields.RowDescriptor-org.firebirdsql.gds.ng.fields.RowValue-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>calculateBlr</h4>
<pre>public&nbsp;byte[]&nbsp;calculateBlr(<a href="../../../../../org/firebirdsql/gds/ng/fields/RowDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">RowDescriptor</a>&nbsp;rowDescriptor,
                           <a href="../../../../../org/firebirdsql/gds/ng/fields/RowValue.html" title="class in org.firebirdsql.gds.ng.fields">RowValue</a>&nbsp;rowValue)
                    throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html#calculateBlr-org.firebirdsql.gds.ng.fields.RowDescriptor-org.firebirdsql.gds.ng.fields.RowValue-">BlrCalculator</a></code></span></div>
<div class="block">Calculates the blr for a specific row value.
 <p>
 This allows to optimize for the actual length of the field.
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html#calculateBlr-org.firebirdsql.gds.ng.fields.RowDescriptor-org.firebirdsql.gds.ng.fields.RowValue-">calculateBlr</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html" title="interface in org.firebirdsql.gds.ng.fields">BlrCalculator</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>rowDescriptor</code> - Row descriptor</dd>
<dd><code>rowValue</code> - Row value</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Byte array with the blr</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - When the <a href="../../../../../org/firebirdsql/gds/ng/fields/RowValue.html" title="class in org.firebirdsql.gds.ng.fields"><code>RowValue</code></a> contains an unsupported field type.</dd>
</dl>
</li>
</ul>
<a name="calculateIoLength-org.firebirdsql.gds.ng.fields.FieldDescriptor-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>calculateIoLength</h4>
<pre>public&nbsp;int&nbsp;calculateIoLength(<a href="../../../../../org/firebirdsql/gds/ng/fields/FieldDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">FieldDescriptor</a>&nbsp;fieldDescriptor)
                      throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html#calculateIoLength-org.firebirdsql.gds.ng.fields.FieldDescriptor-">BlrCalculator</a></code></span></div>
<div class="block">Calculates the io length for the field descriptor.
 <p>
 The return value indicates the length and padding of the type in the buffer
 <ul>
 <li>&lt; 0 : Type is of specified length * -1 and not padded</li>
 <li>== 0 : Type is of dynamic length (which is specified in the buffer as an integer) and padded</li>
 <li>&gt; 0 : Type is of specified length minus 1 (subtracting 1 is required to avoid 0 for types of zero length) and padded</li>
 </ul>
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html#calculateIoLength-org.firebirdsql.gds.ng.fields.FieldDescriptor-">calculateIoLength</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html" title="interface in org.firebirdsql.gds.ng.fields">BlrCalculator</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>fieldDescriptor</code> - Field descriptor</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The io length</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
<a name="calculateIoLength-org.firebirdsql.gds.ng.fields.FieldDescriptor-byte:A-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>calculateIoLength</h4>
<pre>public&nbsp;int&nbsp;calculateIoLength(<a href="../../../../../org/firebirdsql/gds/ng/fields/FieldDescriptor.html" title="class in org.firebirdsql.gds.ng.fields">FieldDescriptor</a>&nbsp;fieldDescriptor,
                             byte[]&nbsp;fieldData)
                      throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html#calculateIoLength-org.firebirdsql.gds.ng.fields.FieldDescriptor-byte:A-">BlrCalculator</a></code></span></div>
<div class="block">Calculates the io length for the field descriptor and actual data.
 <p>
 The return value indicates the length and padding of the type in the buffer
 <ul>
 <li>&lt; 0 : Type is of specified length * -1 and not padded</li>
 <li>== 0 : Type is of dynamic length (which is specified in the buffer as an integer) and padded</li>
 <li>&gt; 0 : Type is of specified length minus 1 (subtracting 1 is required to avoid 0 for types of zero length)
 nd padded</li>
 </ul>
 </p>
 <p>
 This allows to optimize for the actual length of the field.
 </p>
 <p>
 For <code>CHAR</code> (<a href="../../../../../org/firebirdsql/gds/ISCConstants.html#SQL_TEXT"><code>ISCConstants.SQL_TEXT</code></a> the implementation should be consistent
 with the lengths as given by <a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html#calculateBlr-org.firebirdsql.gds.ng.fields.RowDescriptor-org.firebirdsql.gds.ng.fields.RowValue-"><code>BlrCalculator.calculateBlr(RowDescriptor, RowValue)</code></a>.
 </p></div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html#calculateIoLength-org.firebirdsql.gds.ng.fields.FieldDescriptor-byte:A-">calculateIoLength</a></code>&nbsp;in interface&nbsp;<code><a href="../../../../../org/firebirdsql/gds/ng/fields/BlrCalculator.html" title="interface in org.firebirdsql.gds.ng.fields">BlrCalculator</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>fieldDescriptor</code> - Field descriptor</dd>
<dd><code>fieldData</code> - byte array (can be <code>null</code>) with field data.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The io length</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../../index-all.html">Index</a></li>
<li><a href="../../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../../org/firebirdsql/gds/ng/wire/AsynchronousProcessor.html" title="class in org.firebirdsql.gds.ng.wire"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../../org/firebirdsql/gds/ng/wire/DeferredAction.html" title="interface in org.firebirdsql.gds.ng.wire"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../../index.html?org/firebirdsql/gds/ng/wire/DefaultBlrCalculator.html" target="_top">Frames</a></li>
<li><a href="DefaultBlrCalculator.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2001-2019 Jaybird (Firebird JDBC/JCA) team. All rights reserved.</small></p>
</body>
</html>
